<template>
    <div>
        <div class="title-container">
            <div class="campaigns-title">
                Campaigns
                <button
                    v-b-tooltip.hover.right="'Will only be sent to your push Subscriber’s List/Visitors who have opt-in to receiving push Notification.'"
                    class="help-tooltip"
                >
                    <i class="fa fa-question-circle-o" />
                </button>
            </div>
            <b-btn
                class="blue-btn"
                @click="createCampaign(true)"
            >
                <i class="fa fa-plus my-icon" />
                Create new Campaigns
            </b-btn>
        </div>
        <div class="row">
            <div class="col-sm-7">
                <div>
                    Create one time campaigns to your subscribers, send messages directly to your subscriber’s device.
                </div>
                <!-- <div class="subtitle">
                    *Pro-tip: Add in a special thank you discount to sweeten the deal!
                </div> -->
            </div>
        </div>
        <div
            v-if="!drafts || !campaigns || !histories"
            class="mt-5"
        >
            <div
                class="loading-md"
            />
        </div>
        <template v-else>
            <div v-if="drafts.campaigns[0]">
                <div class="table-title">
                    Drafts
                </div>
                <div class="table-responsive">
                    <table class="table-hover">
                        <thead class="table-header">
                            <tr>
                                <th class="table-first-item">
                                    Message's text
                                </th>
                                <th>Created on</th>
                                <th />
                            </tr>
                        </thead>
                        <tbody
                            v-for="(draft, index) in drafts.campaigns"
                            :key="index"
                            class="table-body"
                        >
                            <tr class="table-body-row">
                                <th class="table-first-item">
                                    {{ draft.title }}
                                </th>
                                <th>{{ $formatter.dateFormat(draft.created_at) }}</th>
                                <th class="text-right">
                                    <router-link
                                        :to="'/push/campaigns/add/' + draft.id"
                                        class="btn light-blue-btn"
                                    >
                                        Edit
                                    </router-link>
                                    <b-btn
                                        class="red-button"
                                        @click="deleteCampaign(draft.id)"
                                    >
                                        Remove
                                    </b-btn>
                                </th>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <paginate
                    v-if="Math.ceil(drafts.totalCount / drafts.limit) > 1"
                    v-model="draftPage.number"
                    :page-count="Math.ceil(drafts.totalCount / drafts.limit)"
                    :click-handler="pageDraftHandler"
                    :prev-text="'Previous'"
                    :next-text="'Next'"
                    :container-class="'pagination'"
                />
            </div>
            <div
                v-else
                class="row row-container"
            >
                <div class="col-md-8">
                    Draft will appear here
                </div>
                <div class="col-md-4 not-found">
                    You have no <span>Drafts</span>
                </div>
            </div>
            <div v-if="campaigns.campaigns[0]">
                <div class="table-title">
                    Scheduled
                </div>
                <div class="table-responsive">
                    <table class="table-hover">
                        <thead class="table-header">
                            <tr>
                                <th class="table-first-item">
                                    Message's text
                                </th>
                                <th>Created on</th>
                                <th />
                            </tr>
                        </thead>
                        <tbody class="table-body">
                            <tr
                                v-for="(campaign, index) in campaigns.campaigns"
                                :key="index"
                                class="table-body-row"
                            >
                                <th class="table-first-item">
                                    {{ campaign.title }}
                                </th>
                                <th>{{ $formatter.dateFormat(campaign.updated_at) }}</th>
                                <th class="text-right">
                                    <router-link
                                        :to="'/push/campaigns/add/' + campaign.id"
                                        class="btn light-blue-btn"
                                    >
                                        Edit
                                    </router-link>
                                    <b-btn
                                        class="red-button"
                                        @click="deleteCampaign(campaign.id)"
                                    >
                                        Remove
                                    </b-btn>
                                </th>
                            </tr>
                        </tbody>
                    </table>
                </div>

                <paginate
                    v-if="Math.ceil(campaigns.totalCount / campaigns.limit) > 1"
                    v-model="schedulePage.number"
                    :page-count="Math.ceil(campaigns.totalCount / campaigns.limit)"
                    :click-handler="pageScheduleHandler"
                    :prev-text="'Previous'"
                    :next-text="'Next'"
                    :container-class="'pagination'"
                />
            </div>
            <div
                v-else
                class="row row-container"
            >
                <div class="col-md-8">
                    Scheduled Campaigns will send based on specific times you have set
                </div>
                <div class="col-md-4 not-found">
                    You have no <span>Scheduled Campaigns</span>
                </div>
            </div>
            <div v-if="histories.campaigns[0]">
                <div class="table-title">
                    History
                </div>
                <div class="table-responsive">
                    <table class="table-hover">
                        <thead class="table-header">
                            <tr>
                                <th class="table-first-item">
                                    Subject
                                </th>
                                <th>Sent date</th>
                                <th>Status</th>
                                <th>Sent</th>
                                <th>Clicked</th>
                                <th>CTR (%)</th>
                                <th>Orders</th>
                                <th>CVR, %</th>
                                <th>Revenue</th>
                            </tr>
                        </thead>
                        <tbody class="table-body">
                            <tr
                                v-for="(history, index) in histories.campaigns"
                                :key="index"
                                class="table-body-row"
                            >
                                <th class="table-first-item">
                                    {{ history.title }}
                                </th>
                                <th>{{ history.date }}</th>
                                <th>
                                    <div
                                        v-if="history.in_progress === false"
                                        class="table-status-complete"
                                    >
                                        Completed
                                    </div>
                                    <div
                                        v-if="history.in_progress === true"
                                        class="table-status-process"
                                    >
                                        In Progress
                                    </div>
                                </th>
                                <th>{{ history.send_count }}</th>
                                <th>{{ history.clicks_count }}</th>
                                <th>{{ history.click_rate }}</th>
                                <th>{{ history.orders_count }}</th>
                                <th>{{ history.cvr }}</th>
                                <th>{{ history.revenue }}</th>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <paginate
                    v-if="Math.ceil(histories.totalCount / histories.limit) > 1"
                    v-model="historyPage.number"
                    :page-count="Math.ceil(histories.totalCount / histories.limit)"
                    :click-handler="pageHistoryHandler"
                    :prev-text="'Previous'"
                    :next-text="'Next'"
                    :container-class="'pagination'"
                />
            </div>
            <div
                v-else
                class="row row-container"
            >
                <div class="col-md-8">
                    Your Campaign history will appear here
                </div>
                <div class="col-md-4 not-found">
                    You have no <span>History</span>
                </div>
            </div>
        </template>
    </div>
</template>

<script>
import pushCampaign from '../../../mixins/push/campaigns.service'

export default {
    name: "PushCampaignsContent",
    mixins: [pushCampaign],
    props: ['drafts', 'campaigns', 'histories', 'draftPage', 'schedulePage', 'historyPage'],
    data() {
      return {
        campaign: {}
      }
    },
    methods: {
        pageDraftHandler(e) {
            return this.$emit('getDrafts', e)
        },
        pageScheduleHandler(e) {
            return this.$emit('getCampaigns', e)
        },
        pageHistoryHandler(e) {
            return this.$emit('getHistories', e)
        },
        deleteCampaign(id) {
            this.delete(id).then(response => {
                    this.$notify({
                        type: 'success',
                        title: 'Deleted'
                    });
                    this.$emit('getDrafts')
                    this.$emit('getCampaigns')
                    this.$emit('getHistories')
            }).catch(error =>  {
                console.log(error)
            })
        },
        createCampaign(firstOpen) {
            this.create({}, firstOpen).catch((error) => {
                console.log(error)
            });
        }
    }
}
</script>

<style scoped lang="scss">


.table-title {
    font-size: 28px;
    font-weight: bold;
    margin-left: 13px;
    margin-top: 45px;
}

.row-container {
    margin-top: 40px;
}

.not-found {
    font-size: 18px;
    color: #b3b9c4;
    font-weight: 900;
    text-align: right;
}

.table-status-complete {
    color: #2BB300;
}

.not-found span {
    color: #03183B;
}

.campaigns-title {
    font-size: 28px;
    font-weight: bold;
}

.subtitle {
    font-size: 11px;
}

.title-container {
    display: flex;
    justify-content: space-between;
    align-items: center;
    margin-bottom: 25px;
    @media screen and (max-width: 500px) {
        flex-direction: column;
        align-items: baseline;
    }
}

.blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 15px;
    }
}

.my-icon {
    color: white;
    margin-right: 8px;
    font-size: 17px;
}

.table-first-item {
    text-align: start !important;
}

.table-hover tr {
    border-bottom: 3px solid #F5F6FA;
    border-radius: 10px;
}

.table-header {
    padding: 10px;
}

.table-body {
    background: white;
    border-radius: 10px;
}

.table-hover tbody tr:hover {
    background-color: #fbfcfd;
}
.help-tooltip {
    margin-left: -5px;
}
.tooltip {
    &-inner {
        background: #fff;
        color: #98a0a6;
        font-size: 13px;
        padding: 7px 12px;
        border-radius: 4px;
        text-align: left;
        border: 1px solid #dae7ff;
    }
}
</style>

<style >
.tooltip .arrow::before{ 
    border-right-color: #98a0a6;
}
</style>
